MishaTools_LoadScripts.RequireOnce(
['MishaTools/Canvas.js'],
function() {
	MishaTools_Canvas_Cache = Class.create({
		initialize:function() {
			var canvas = new Element('canvas');
			this.context = canvas.getContext('2d');
			this.free = true;
		},
		
		checkout:function(size) {
			this.free = false;
			MishaTools_Canvas.ResetContext(this.context,size);
			this.context.save();
		},
		
		release:function() {
			this.free = true;
			this.context.restore();
		},
		
		save:function() {
			return this.context.getImageData(0,0,this.context.canvas.width,this.context.canvas.height);
		}
	});
	
	Object.extend(MishaTools_Canvas_Cache,{
		GetFreeCache:function(size) {
			var cache = MishaTools_Canvas_Cache.Stack.find(function(cache) {
				return cache.free;
			});
			
			if(!cache) {
				cache = new MishaTools_Canvas_Cache();
				MishaTools_Canvas_Cache.Stack.push(cache);
			}
			
			cache.checkout(size);
			return cache;
		},
		Stack:[]
	});
});