MishaTools_LoadScripts.RequireOnce(
['MishaTools/Canvas/Rect.js'],
function() {
	MishaTools_Canvas_Rect_Shape = Class.create(MishaTools_Canvas_Rect,{
		initialize:function($super,id) {
			$super(id);
			
			this.setOptionDefinitions({
				fill:{render:true},
				stroke:{render:true},
				size:{render:true}
			});
		},
		
		_render:function(ctx) {
		
			var fill = this.getOptions('fill');
			var stroke = this.getOptions('stroke');
			
			if(fill) {
				ctx.fillStyle = fill;
				ctx.fill();
			}

			if(stroke) {
				if(Object.isArray(stroke)) {
					if(stroke[0]) ctx.strokeStyle = stroke[0];
					if(stroke[1]) ctx.lineWidth = stroke[1];
				} else {
					ctx.strokeStyle = stroke;
				}
				ctx.stroke();
			}
		}
	});
});