MishaTools_LoadScripts.RequireOnce(
['MishaTools/Dependency.js'],
function() {

	$DT = function(rate,limit) {
		return new MishaTools_Dependency_Time(rate,limit);
	};
	
	MishaTools_Dependency_Time = Class.create(MishaTools_Dependency,{
		initialize:function($super,rate,limit) {
			$super(0); //frame zero
			
			this.start(rate,limit);
		},
		
		start:function(rate,limit) {
			if(rate) {
				this.stepper = new PeriodicalExecuter(function(pe) {
					this.change(this.value + 1); //represents the frame
					
					if(limit && this.value == limit) {
						pe.stop();
						this.fire('end',{limitReached:true});
					}
				}.bindAsEventListener(this),rate);
				this.fire('start');
			}
		},
		
		stop:function() {
			if(this.stepper) {
				this.stepper.stop();
				this.fire('end',{limitReached:false});
			}
		}
	});
});