MishaTools_LoadScripts.RequireOnce(
['MishaTools/Canvas/Object.js'],
function() {
	MishaTools_Canvas_Rect = Class.create(MishaTools_Canvas_Object,{
		
		initialize:function($super,id) {
			$super(id);
			
			this.setOptions({
				rotation:0
			});
			
			this.setOptionDefinitions({
				size:{
					func:function(parentsize) { return parentsize || $C(0); },
					dependencies:[$PO(this,'size')]
				},
				transform:{
						func:function(transform,rotation,size) { return transform.rotateAroundPoint(size.divide(2),rotation); },
						dependencies:
						[$O(this,'rotation'),
						$O(this,'size')],
						override:true
					}
			});
		},
		
		_bounds:function(ctx) {
			var size = this.getOptions('size');
			ctx.rect(0,0,size.x,size.y);
		}
	});
});