MishaTools_LoadScripts.RequireOnce(
['MishaTools/Canvas/Rect.js'],
function() {
	MishaTools_Canvas_Rect_Image = Class.create(MishaTools_Canvas_Rect,{
		
		initialize:function($super,id) {
			$super(id);
			
			this.setOptionDefinitions({
				image:{render:true},
				size:{render:true}
			});
		},
		
		_render:function(ctx) {
			var image = this.getOptions('image');
			var size = this.getOptions('size');
			ctx.drawImage(image,0,0,size.x,size.y);
		}
	});
	
	Object.extend(MishaTools_Canvas_Rect_Image,{
		FromDOMImage:function(id,domimage,nosize) {
			var image = new MishaTools_Canvas_Rect_Image(id);
			image.setOptions({image:domimage});
			
			if(!nosize) {
				image.setOptionDefinitions({
					size:{
							func:function(image) {
								return image ? $C(image.width,image.height) : $C(0);
							},
							dependencies:[$O(image,'image')]
					}
				});
			}
			return image;
		}
	});
});