MishaTools_LoadScripts.RequireOnce(
['MishaTools/Canvas/Rect/Shape.js'],
function() {
	MishaTools_Canvas_Rect_Shape_Triangle = Class.create(MishaTools_Canvas_Rect_Shape,{

		_render:function($super,ctx) {
			var size = this.getOptions('size');
			MishaTools_Canvas_Rect_Shape_Triangle.TrianglePath(size.divide(2),size,0,ctx);
			
			$super(ctx);
		}
	});
	
	Object.extend(MishaTools_Canvas_Rect_Shape_Triangle,{
		TrianglePath:function(origin,size,theta,ctx) {
			ctx.save();
			ctx.translate(origin.x,origin.y);
			ctx.rotate(theta);
			ctx.moveTo(-size.x/2,size.y/2);
			ctx.lineTo(0,-size.y/2);
			ctx.lineTo(size.x/2,size.y/2);
			ctx.lineTo(-size.x/2,size.y/2);
			ctx.restore();
		}
	});
});