MishaTools_LoadScripts.RequireOnce(
['MishaTools/Canvas/Rect.js',
'MishaTools/Canvas/Rect/Text/Interactive.js',
'MishaTools/Canvas/Rect/Shape/Rectangle.js'],
function() {
	MishaTools_Canvas_Rect_Textbox = Class.create(MishaTools_Canvas_Rect,{
		
		initialize:function($super,id) {
			$super(id);
			
			this.setOptions({
				margin:$C(5)
			});
			
			var text = new MishaTools_Canvas_Rect_Text_Interactive('text');
			var background = new MishaTools_Canvas_Rect_Shape_Rectangle('background');
			
			text.setOptionDefinitions({
				size:{
					func:function(size,margin) { return size.subtract(margin.multiply(2)); },
					dependencies:[$O(this,'margin')],
					override:true
				},
				origin:{
					func:function(origin,margin) { return origin.add(margin); },
					dependencies:[$O(this,'margin')],
					override:true
				}
			});
			
			this.addChild(background);
			this.addChild(text);
		},
		
		tab:function() {
			this.getChild('text').tab();
		}
	});
});