MishaTools_LoadScripts = {
	loadedscripts:[],
	
	_Include:function (url, testobject, callback) {
		var script = new Element('script', { type: 'text/javascript', src: url, async:true });
		$$('head')[0].appendChild(script);
		
		this.loadedscripts.push(url);
		
		var loadstart = +new Date();
		new PeriodicalExecuter(
			function(pe) { 
				if(typeof window[testobject] != 'undefined') {
					pe.stop();
					callback();
				} else if(+new Date() - loadstart > 10000) {
					pe.stop();
					throw new Error('LoadScripts',url + ' cannot be found.');
				}
			},
		1/60);
	},
	
	RequireOnce:function(scripts, callback) {
		if(scripts.length == 0) {
			callback();
		} else {
			var urlobj = scripts.shift();
			var url;
			var testobject;
			
			if(Object.isArray(urlobj)) {
				url = urlobj[0];
				testobject = urlobj[1];
			} else {
				url = urlobj;
				
				var classnamearray = url.split('/').compact();
				
				/*if(this.reserveddirs) {
					for(var i = 0;i<this.reserveddirs.length;i++) {
						var reserveddirarray = this.reserveddirs[i].split('/');
						
						if(urlarray.all(function(n,j) { return (j >= reserveddirarray.length) || (n == reserveddirarray[j]); })) {
							urlarray.splice(0,reserveddirarray.length);
							break;
						}
					}
				}*/
				
				classnamearray[classnamearray.length-1] = classnamearray[classnamearray.length-1].split('.')[0];
				
				var classname = classnamearray.join('_');
				testobject = classname;
				
				var urlarray = url.split('/').compact();
				
				//only use basedir if output is not explicit
				if(this.basedir) {
					var basedirarray = this.basedir.split('/').compact();
					url = basedirarray.concat(urlarray).join('/');
				}
			}
			
			if(this.loadedscripts.indexOf(url) == -1) {
				this._Include(url,testobject,this.RequireOnce.bind(this,scripts,callback));
			} else {
				this.RequireOnce(scripts,callback);
			}
		}
	},
	
	SetBaseDirectory:function(basedir) {
		this.basedir = basedir;
	}
};